#include "StdAfx.h"
#include "CutterLocation.h"
#include <cmath>

#define  PI 3.141592653589793

CCutterLocation::CCutterLocation(void)
{
}

CCutterLocation::CCutterLocation(double l[6])
{
	toolCenter.x = l[0];
	toolCenter.y = l[1];
	toolCenter.z = l[2];
	toolNormal.x = l[3];
	toolNormal.y = l[4];
	toolNormal.z = l[5];	
}

CCutterLocation::CCutterLocation(CPoint3D tc, CVector3D tn)
{
	toolCenter = tc;
	toolNormal = tn;
}

CCutterLocation::~CCutterLocation(void)
{
}


CMachineCoordinate CCutterLocation::MachineCoordinate()
{
	// ģ
	double x = toolCenter.x;
	double y = toolCenter.y;
	double z = toolCenter.z;

	// ʸ
	toolNormal.Normalize();
	double aX = toolNormal.x;
	double aY = toolNormal.y;
	double aZ = toolNormal.z;

	// 
	double mcX = 0;
	double mcY = 0;
	double mcZ = 0;
	double mcA = 0;
	double mcC = 0;

	// A
	if (aY <= 0)
	{
		if (aZ  != 0 )
			mcA = atan( sqrt(aX * aX + aY * aY) / aZ);

		else if(aZ == 0 )
			mcA = PI / 2;
	}
	else
	{
		if (aZ  != 0 )
			mcA = atan( sqrt(aX * aX + aY * aY) / aZ);

		else if (aZ == 0 )
			mcA = -PI / 2;
	}

	// C
	if (aX >= 0)
	{
		if (aY < 0)
			mcC = atan( abs(aX / aY) );
		else if (aY == 0)
			mcC = PI / 2;
		else
			mcC = PI - atan( abs(aX / aY) );
	}
	else
	{
		if (aY < 0)
			mcC = -atan( abs(aX / aY) );
		else if (aY == 0)
			mcC = -PI / 2;
		else
			mcC = -PI + atan( abs(aX / aY) );
	}

	// X, Y, Z
	// 赶Ϊ10 mm
	double lTool = 10;
	mcX = x + lTool * sin(mcA) * sin(mcC);
	mcY = y - lTool * sin(mcA) * cos(mcC);
	mcZ = z + lTool * cos(mcA);

	return CMachineCoordinate(mcX, mcY, mcZ, mcA * 180.0 / PI, mcC * 180.0 / PI);
}