
//********************************************************************
//	created:	2006-1-16  16:11
//	filename: 	Point3D.h
//	file base:	Point3D
//	author:		пԺȽоԺ Ӽ (Liangliang Nan)
//  E-mail:     liangliang.nan@gmail.com
// 
//	
//	purpose:	interface for the CPoint3D class.
//*********************************************************************

#if !defined _POINT3D_H_
#define _POINT3D_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <vector>
using namespace std;

class AFX_EXT_CLASS CPoint3D
{
public:
	CPoint3D()
	{
		x = 0.0f;
		y = 0.0f;
		z = 0.0f;
	}

	CPoint3D(const CPoint3D &point)
	{
		x = point.x;
		y = point.y;
		z = point.z;
	}

	CPoint3D(float X, float Y, float Z)
	{
		x = X;
		y = Y;
		z = Z;
	}

	virtual ~CPoint3D() {}

	void operator =(const CPoint3D &point)
	{
		x = point.x;
		y = point.y;
		z = point.z;
	}

	bool operator <(const CPoint3D &point) const
	{	return (   (x < point.x )
			|| ((x == point.x) && (y < point.y))
			|| ((x == point.x) && (y == point.y) && (z < point.z)));
	}

	//ǳΪغ
	bool operator ==(const CPoint3D &point) const
	{
		return this->SquaredDistance(point) == 0 ;
	}

	// 룬þƽ
	float SquaredDistance(const CPoint3D& point) const 
	{
		return (x - point.x) * (x - point.x) + (y - point.y) * (y - point.y) + (z - point.z) * (z - point.z);
	}


public:
	float x;
	float y;
	float z;
};

#endif // !defined(_POINT3D_H_)
