#include "StdAfx.h"
#include "ToolPath.h"
#include <fstream>
#include <stdio.h>
#include <cmath>

#import "regexp.tlb" no_namespace 


CToolPath::CToolPath(void)
{
	nListToolPath = 0;
	
	m_dMinX = 0.0;  m_dMinY = 0.0;  m_dMinZ = 0.0;
	m_dMaxX = 0.0;  m_dMaxY = 0.0;  m_dMaxZ = 0.0;

	m_dCenterX = 0.0; m_dCenterY = 0.0; m_dCenterZ = 0.0;

	m_dFitWndScale = 1.0;

	m_bMachineCoordinatesDone = false;
	m_bExistToolPath = false;
}

CToolPath::~CToolPath(void)
{
}


void CToolPath::ReadToolPathFile(LPCTSTR file)
{
 	CoInitialize(NULL);
 	CStdioFile file_src;
 	CStringArray strArray;
 	file_src.Open(file, CFile::modeRead|CFile::typeText);
	
	CString strTemp;
	double dblValue[6]={0, 0, 0, 0, 0, 0};
	while(file_src.ReadString(strTemp))
	{
		IRegExpPtr regExp(__uuidof(RegExp));
		regExp->PutGlobal(VARIANT_TRUE);
		regExp->PutPattern("([-]?\\d+.\\d+)");
		LPCTSTR str = (LPCTSTR)strTemp;
		IMatchCollectionPtr matches=regExp->Execute(str);
		int c=matches->Count;
		
		if (c == 6 || c == 3)
		{			
			for (int i=0; i<matches->Count; i++)
			{
				IMatchPtr match = matches->Item[i];
				int first =match->FirstIndex;
				int length =match->Length;
				CString strValue = strTemp.Mid(first,length);
				dblValue[i] = atof((LPCTSTR)strValue);
			}
			
			CCutterLocation cl(dblValue);
			vecCutterLocations.push_back(cl);
		}
	}
	
	file_src.Close();

	// ΪλʱλЧ
	if (vecCutterLocations.size() > 2)
		m_bExistToolPath = true;
	else
	{
		AfxMessageBox("뵶λļʧܣ");
		return;
	}

	CalculateFitWndPara();

	BuildListToolPath();
}

/*
#include "stdafx.h"
//ʹVC++ԴķʽVBScript.dllѡTypeLib2TypeLibΪregexp.tlb
#import "regexp.tlb" no_namespace

int main(int argc, char* argv[])
{
	CoInitialize(NULL);
	{
		IRegExpPtr regExpPtr(__uuidof(RegExp));
		regExpPtr->PutGlobal(VARIANT_TRUE);
		regExpPtr->PutPattern("(\\d+\\.?\\d*|\\.\\d+)");
		LPCTSTR testStr = "This 1dd2d";
		IMatchCollectionPtr matches = regExpPtr->Execute(testStr);//ָҪ
		
		int count = matches->GetCount();//count=0 ж matches Ӧȷ 
		for(int i=0; i<count; i++)
		{
			IMatchPtr match=matches->GetItem((long)i);
			if(match)
			{
				printf("%s\n",(LPCTSTR)match->GetValue());
			}
		}
	}
	
	CoUninitialize();
	printf("Test of using regular expression in VC++!\n");
	return 0;
}

*/


void CToolPath::CalculateFitWndPara()
{
	//еXYZСֵ
	m_dMinX = vecCutterLocations[0].toolCenter.x;
	m_dMaxX = vecCutterLocations[0].toolCenter.x;
	m_dMinY = vecCutterLocations[0].toolCenter.y;
	m_dMaxY = vecCutterLocations[0].toolCenter.y;
	m_dMinZ = vecCutterLocations[0].toolCenter.z;
	m_dMaxZ = vecCutterLocations[0].toolCenter.z;

	for (unsigned long i = 1; i < vecCutterLocations.size(); ++i)
	{
		m_dMinX = vecCutterLocations[i].toolCenter.x < m_dMinX ? vecCutterLocations[i].toolCenter.x : m_dMinX;
		m_dMinY = vecCutterLocations[i].toolCenter.y < m_dMinY ? vecCutterLocations[i].toolCenter.y : m_dMinY;
		m_dMinZ = vecCutterLocations[i].toolCenter.z < m_dMinZ ? vecCutterLocations[i].toolCenter.z : m_dMinZ;

		m_dMaxX = vecCutterLocations[i].toolCenter.x > m_dMaxX ? vecCutterLocations[i].toolCenter.x : m_dMaxX;
		m_dMaxY = vecCutterLocations[i].toolCenter.y > m_dMaxY ? vecCutterLocations[i].toolCenter.y : m_dMaxY;
		m_dMaxZ = vecCutterLocations[i].toolCenter.z > m_dMaxZ ? vecCutterLocations[i].toolCenter.z : m_dMaxZ;
	}
	
	// Χ X,Y,Z 
	m_dCenterX = (m_dMaxX + m_dMinX) / 2.0;
	m_dCenterY = (m_dMaxY + m_dMinY) / 2.0;
	m_dCenterZ = (m_dMaxZ + m_dMinZ) / 2.0;

	m_dFitWndScale = 1.0 / max(fabs(m_dMaxX - m_dCenterX), max(fabs(m_dMaxY - m_dCenterY), fabs(m_dMaxZ - m_dCenterZ)));
}


void CToolPath::BuildListToolPath()
{
	nListToolPath = glGenLists(1);
	glNewList(nListToolPath, GL_COMPILE);
		glColor3ub(255, 255, 255);
		glLineWidth(2.0f);
		glPointSize(3.0f);
		glBegin(GL_LINE_STRIP);
			for (unsigned long i = 0; i < vecCutterLocations.size(); ++i)
			{
				glNormal3f(vecCutterLocations[i].toolNormal.x,
						   vecCutterLocations[i].toolNormal.y, 
						   vecCutterLocations[i].toolNormal.z);
				glVertex3f(vecCutterLocations[i].toolCenter.x,
					       vecCutterLocations[i].toolCenter.y, 
					       vecCutterLocations[i].toolCenter.z);
			}
		glEnd();
	glEndList();
}

void CToolPath::Draw()
{
	glTranslated(-m_dCenterX, -m_dCenterY, -m_dCenterZ);	
	glCallList(nListToolPath);	
}


void CToolPath::CalculateMachineCoordinates(vector< CMachineCoordinate > &vecMachineCoordinates)
{	
	if (!m_bExistToolPath)
	{
		AfxMessageBox("·ڣ");
		return;
	}
	
	if (m_bMachineCoordinatesDone)
	{
		AfxMessageBox("Ѿ!");
		return;
	}
		
	for (unsigned long i = 0; i < vecCutterLocations.size(); ++i)
		vecMachineCoordinates.push_back(vecCutterLocations[i].MachineCoordinate());
	m_bMachineCoordinatesDone = true;
}
