
//********************************************************************
//	created:	2006-1-16  16:12
//	filename: 	Vector3D.h
//	file base:	Vector3D
//	author:		пԺȽоԺ Ӽ (Liangliang Nan)
//  E-mail:     liangliang.nan@gmail.com
// 
//	
//	purpose:	interface for the CVector3D class.
//*********************************************************************

#if !defined _VECTOR3D_H_
#define _VECTOR3D_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CPoint3D;

class AFX_EXT_CLASS CVector3D  
{
public:
	CVector3D();
	CVector3D(float x, float y, float z);
	CVector3D(CPoint3D source, CPoint3D dest);
	CVector3D(const float*);
	CVector3D(const CVector3D& v);

	virtual ~CVector3D();

	//operator
	CVector3D operator +(CVector3D v) const;	
	CVector3D operator -(CVector3D v) const;
	void operator -=(CVector3D v);
	void operator +=(CVector3D v);

	CVector3D operator *(float d) const;
	CVector3D operator /(float d) const;
	void operator *=(float d);
	void operator /=(float d);

	//cross product
	CVector3D operator *(CVector3D v) const;
	
	//dot product
	float operator |(CVector3D v) const;
	float DotProduct(CVector3D v) const;


	//length
	float GetLength() const;
	float GetSquaredLength() const;
	float GetLengthXY() const;
	float GetLengthYZ() const;
	float GetLengthZX() const;
	
	CVector3D	GetNormal() const;
	void		Normalize();


public:
	float x;
	float y;
	float z;
};

#endif // !defined(_VECTOR3D_H_)
