
//********************************************************************
//	created:	2006-3-16  19:09
//	filename: 	inc\DlgMaterial\DlgMaterial.h
//	file base:	DlgMaterial
//	author:		пԺԶо RPʵ 
//  E-mail:     nanlliang@sia.cn
// 
//	
//	purpose:	ֲʣû޸ĲԶԻ
//*********************************************************************

////////////////////////////////////////////////////////
// DlgMaterial.h : class CDlgMaterial
//
// The Class CDlgMaterial is a class for selection of material properties.

// It offers many mechanisms for selection:
//	-	Direct selection from the programcode
//		Selection by index 

//	-	Selection from a dialogbox with a combo box
//		That is why the class is based on CDialog (IDD_MULTI)

//	-	Selection by menu. The class offers to
//		construct a CMenu from actual strings. 
//		This CMenu can in turn be attached to 
//		a windows menu, or appear as a popup

//	-	CDlgMaterial can also be used as a static object
//		Function SetMaterial may be called directly,
//		without declaring a CDlgMaterial object. If you include
//		DlgMaterial.h in stdAfx.h, the call CDlgMaterial::SetMaterial
//		is allways available
// 
/////////////////////////////////////////////////////////


#ifndef _DLGMATERIAL_H_
#define _DLGMATERIAL_H_


// enum to identify all the materials
// extracted to .h file to make it available
// for using class


class CDlgMaterial : public CDialog
{
public:
	static void SetMaterial(UINT ix, GLenum gSide = GL_FRONT);
	// realizes a material without changing locals (of course)

	static UINT Get_Material_Count(){return NUM_MATERIALS;};
	// returns the number of materials

	UINT Build_Menu(UINT FirstID,CMenu *pM);
	// fills a menu from all the strings

	UINT Build_Combo(CComboBox* pCB);
	// fills a combo box from all the strings

	UINT Get_Current_Index();
	// returns the current selection

	void Get_Current_Name(CString& S);
	// returns the name associated with the current selection

	void Set_Current_Index(UINT ix);
	// changes the current selection without action

	void Do_Selection(GLenum gSide = GL_FRONT_AND_BACK);
	// perform the current selection

	void Select_And_Do(UINT ix, GLenum gSide = GL_FRONT_AND_BACK);
	// combination of the two above

public:
	CDlgMaterial(CWnd* pParent = NULL);
	
	// Dialog Data
	//{{AFX_DATA(CDlgMaterial)
	enum { IDD = IDD_MATERIAL };
	CComboBox	m_Combo;
	//}}AFX_DATA	
	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgMaterial)
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	UINT m_CurrentIndex;
	// current selection, always legitimate
	
	void Do_It(GLenum gSide);
	// realize current selection
	
	CString Get_Name(UINT ix);
	// return the name string with index ix
	
protected:
	
	// Generated message map functions
	//{{AFX_MSG(CDlgMaterial)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif //_DLGMATERIAL_H_
