
//********************************************************************
//	created:	2006-1-15  15:25
//	filename: 	OpenGLView.cpp
//	file base:	OpenGLView
//	author:		пԺȽоԺ Ӽ (Liangliang Nan)
//  E-mail:     liangliang.nan@gmail.com
// 
//	
//	purpose:	implementation file of COpenGLView class
//*********************************************************************


#include "stdafx.h"
#include "OpenGLView.h"
#include <cmath>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COpenGLView

IMPLEMENT_DYNCREATE(COpenGLView, CView)

COpenGLView::COpenGLView()
{
	m_hRC = NULL;

	InitGeometry();
}


COpenGLView::~COpenGLView()
{
}


BEGIN_MESSAGE_MAP(COpenGLView, CView)
//{{AFX_MSG_MAP(COpenGLView)
ON_WM_CREATE()
ON_WM_SIZE()
ON_WM_DESTROY()	
ON_WM_ERASEBKGND()
ON_WM_LBUTTONDOWN()
ON_WM_LBUTTONUP()
ON_WM_MOUSEMOVE()
ON_WM_RBUTTONDOWN()
ON_WM_RBUTTONUP()
//}}AFX_MSG_MAP
ON_WM_TIMER()
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// COpenGLView diagnostics

#ifdef _DEBUG
void COpenGLView::AssertValid() const
{	CView::AssertValid();}

void COpenGLView::Dump(CDumpContext& dc) const
{	CView::Dump(dc);}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COpenGLView drawing
void COpenGLView::OnDraw(CDC* pDC)
{
	// CDocument* pDoc = GetDocument();
	
	// you will always want to redefine this in your subclass
	// Here we assume that the one and only rendering context is selected
	// If it for some reason is not, this must be
	// done before we do any OpenGL-action

	// Clear the color and depth buffers.
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// Set up for scene
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glPushMatrix();
		// ƽ
		glTranslatef(m_xTranslation, m_yTranslation, m_zTranslation);
	
		// ת
		glRotatef(m_xRotation, 1.0, 0.0, 0.0);
		glRotatef(m_yRotation, 0.0, 1.0, 0.0);
		glRotatef(m_zRotation, 0.0, 0.0, 1.0);

		// 
		glScalef(m_Scaling, m_Scaling, m_Scaling);	
		
		// ûйʱģɫΪɫڻʱܸıɫ
		glColor3ub(255, 255, 255);

		glPolygonMode(GL_FRONT_AND_BACK, m_enDisplayMode);
		RenderSceneScalable();
	glPopMatrix();	

	glPushMatrix();
		glTranslatef(-1.95, -1.05, 0);  // Ƶ½
	
		glRotatef(m_xRotation, 1.0, 0.0, 0.0);
		glRotatef(m_yRotation, 0.0, 1.0, 0.0);
		glRotatef(m_zRotation, 0.0, 0.0, 1.0);

		// 
		if (m_bShowCoordinate)
		{
			GLboolean bLightOn = glIsEnabled(GL_LIGHTING);
			if (bLightOn)
				glDisable(GL_LIGHTING);  //رչգx,y,z᲻ܹӰ죬ֱΪ죬̣

			// һϵвŵ
			RenderSceneUnScalable();

			if (bLightOn)
				glEnable(GL_LIGHTING);   //󣬹սֹ˴ָ
		}
	glPopMatrix();

	// finish drawing
	glFlush();
	SwapBuffers(wglGetCurrentDC());	
}


void COpenGLView::RenderSceneScalable()
{
	//glutSolidSphere(0.3f, 20, 20);
	glutSolidTeapot(1.0f);
}


void COpenGLView::RenderSceneUnScalable()
{
	glCallList(m_nAxisesList);
}

void COpenGLView::EnableLighting(bool b)
{
	m_bEnableLighting = b;
	if (b)
		glEnable(GL_LIGHTING);
	else
		glDisable(GL_LIGHTING);
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView message handlers
int COpenGLView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	// sets up the drawing environment and do
	// one time initialization of OpenGL-settings
	
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	HWND hWnd = GetSafeHwnd();
	HDC  hDC = ::GetDC(hWnd);
	
	// Set up the drawing environment
	if (SetWindowPixelFormat(hDC) == FALSE)
		return -1;
	if (CreateViewGLContext(hDC) == FALSE)
		return -1;

	// do one-time initializing
	InitRenderContext();
	PrepareAxisLabel();
	BuildAxisesList();
	
	return 0;
}


void COpenGLView::OnDestroy() 
{	
	CView::OnDestroy();	
	// TODO: Add your message handler code here
	if(wglGetCurrentContext() != NULL)
		wglMakeCurrent(NULL,NULL);

	if(m_hRC != NULL)
	{
		wglDeleteContext(m_hRC);
		m_hRC = NULL;
	}
}


void COpenGLView::OnSize(UINT nType, int cx, int cy) 
{	
	CView::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
	
	// Called whenever the size of the view changes
	// We must regulate the view port in the rendering
	// context accordingly. Here we assume that the 
	// one and only rendering context is selected
	// If it for some reason is not, this must be
	// done before we do any OpenGL-action	
	
	// use the whole client area
	glViewport(0, 0, cx, cy);
	
    // We will work on the projection matrix,
	// so set matrix mode
	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	
	// set up your viewing volume
	float aspect = (cy == 0) ? cx : cx / (float)cy;
	// NOTE: want x/y-ratio to match view ports x/y-ratio
	// Alternative: glOrtho:box, parallel projection
	glOrtho(m_OrthoRangeLeft * aspect, m_OrthoRangeRight * aspect,
		m_OrthoRangeBottom, m_OrthoRangeTop,
		m_OrthoRangeNear, m_OrthoRangeFar);	
	
	// set back matrix mode
	glMatrixMode(GL_MODELVIEW);	
	glLoadIdentity();
}


BOOL COpenGLView::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
	
	// To avoid flicker. This assures that
	// the client area is not blanked before a redraw starts
	// OK as long as we draw in the whole client area
	return TRUE;
}


BOOL COpenGLView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	// all OpenGL windows must have this window-style
	
	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
	return CView::PreCreateWindow(cs);
}


void COpenGLView::InitGeometry()
{
	// m_nCurrentMatIndex = 25; 
	m_nCurrentMatIndex = 7;
	m_nFontOffset = 0;
	m_nAxisesList = 0;

	m_enDisplayMode = GL_FILL;	
	
	m_bEnableLighting = true;
	m_bEnableBothSidesLights = true;
	m_bEnableAntiAliasing = true;
	m_bShowCoordinate = true;

	m_bLeftButtonDown = false;
	m_bRightButtonDown = false;
	
	m_bXZRotation = true;
	m_xRotation = -90.0;
	m_yRotation = 0.0;
	m_zRotation = 0.0;

	m_Scaling = 1.0f;	
	m_xTranslation = 0.0f;
	m_yTranslation = 0.0f;
	m_zTranslation = 0.0f;	

	//FitWindowʱʹ
	m_bLockScaleAndTrans = false;
	m_stepScaling = 0.0f;
	m_stepTransX = 0.0f;
	m_stepTransY = 0.0f;
	m_stepTransZ = 0.0f;
	
	m_SpeedScaling = 1.05;
	m_SpeedRotation = 1.0f / 3.0f;
	m_SpeedTranslation = 1.0f / 212.0f;
	
	// ת;
	m_StepRotationX = 0.0f;
	m_StepRotationY = 5.0f;
	m_StepRotationZ = 0.0f;
	
	// ɫ;
	m_BackColorRed = 0.0f;
	m_BackColorGreen = 0.0f;
	m_BackColorBlue = 0.0f;
	m_BackAlpha = 1.0f;

	//ƽͶӰ
	m_OrthoRangeLeft = -1.5f;
	m_OrthoRangeRight = 1.5f;
	m_OrthoRangeBottom = -1.5f;
	m_OrthoRangeTop = 1.5f;
	m_OrthoRangeNear = -50.0f;
	m_OrthoRangeFar = 50.0f;
}

void COpenGLView::SetBackGroundColor(COLORREF color)
{
	m_BackColorRed   = GetRValue(color) / 255.0f;
	m_BackColorGreen = GetGValue(color) / 255.0f;
	m_BackColorBlue  = GetBValue(color) / 255.0f;

	glClearColor(m_BackColorRed, m_BackColorGreen, m_BackColorBlue, m_BackAlpha);
	InvalidateRect(NULL);
}


void COpenGLView::SetMaterial(UINT nMatIndex /* = 10 */, GLenum gSide /* = GL_FRONT_AND_BACK */)
{
	nMatIndex = max(0, min(static_cast<int>(NUM_MATERIALS - 1), static_cast<int>(nMatIndex)));

	// helper to fill the vector
	// use GL_FRONT when erronous gSide-value
	if((gSide != GL_FRONT_AND_BACK) && (gSide != GL_BACK))
		gSide = GL_FRONT;

	GLfloat *pMat = Material[nMatIndex];
	
	glMaterialfv(gSide, GL_AMBIENT, pMat);
	pMat += 4;
	glMaterialfv(gSide, GL_DIFFUSE, pMat);
	pMat += 4;
	glMaterialfv(gSide, GL_SPECULAR, pMat);
	pMat += 4;
	glMaterialf(gSide, GL_SHININESS, *pMat * 128.0f);	
}


//////////////////////////////////////////////////
// default one-time initialization
void COpenGLView::InitRenderContext()
{
	// Here we set the attributes that probably
	// will be constant during the rendering 
	// contexts lifetime.
	
	// you may or may not want this function
	// if you don't need it, simply redefine an empty
	// function in your subclass

    glEnable(GL_DEPTH_TEST);
    glDepthFunc(GL_LESS);

	//////////////////////////////////////////////////////////////////////////
	// 
	// prepare light source
	GLfloat ambient[]  = {0.7f, 0.7f, 0.7f, 1.0f};
	GLfloat diffuse[]  = {0.8f, 0.8f, 0.8f, 1.0f};
	GLfloat specular[] = {0.5f, 0.5f, 0.5f, 1.0f};
	GLfloat position[] = {10000.0f, 10000.0f, 50000.0f, 1.0f};
	GLfloat global_ambient[] = { 0.8f, 0.8f, 0.8f, 1 };

	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
	glLightfv(GL_LIGHT0, GL_POSITION, position);
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);

	SetMaterial(m_nCurrentMatIndex);

	//float MatAmbientBack[]  = {0.2f, 0.2f, 0.0f, 1.0f}; // ƫ
	float MatAmbientBack[]  = {0.1f, 0.2f, 0.0f, 1.0f}; // ƫ
	glMaterialfv(GL_BACK, GL_AMBIENT, MatAmbientBack);

	// Ƿ˫
	if (m_bEnableBothSidesLights)
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE); 
	else
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);

	//ӵ
//	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE);

	if (m_bEnableLighting)
	{
 		glEnable(GL_LIGHTING);	
 		glEnable(GL_LIGHT0);
	}

	// ޳湦
	//glEnable(GL_CULL_FACE);
	//glCullFace(GL_BACK);

	// flat / smooth the drawing
	glShadeModel(GL_SMOOTH);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL); 	

	//÷
	if (m_bEnableAntiAliasing)
	{
		glEnable(GL_POINT_SMOOTH);
		glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);

		glEnable(GL_LINE_SMOOTH);
		glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);

		glEnable(GL_BLEND);
		glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	}
	else
	{
		glDisable(GL_POINT_SMOOTH);
		glDisable(GL_LINE_SMOOTH);
		glDisable(GL_BLEND);
	}

	// λ
 	glEnable(GL_NORMALIZE);
	glEnable(GL_AUTO_NORMAL);

    // set background to black
	glClearColor(m_BackColorRed, m_BackColorGreen, m_BackColorBlue, m_BackAlpha);
}


// SetWindowPixelFormat
BOOL COpenGLView::SetWindowPixelFormat(HDC hDC)
{
	// make sure we do only one initialization
	static bool m_bIsInitialized = FALSE;
	ASSERT(!m_bIsInitialized);
	m_bIsInitialized = TRUE;	
	
	static PIXELFORMATDESCRIPTOR pfd = 
	{
        sizeof(PIXELFORMATDESCRIPTOR),      // size of this pfd
			1,                              // version number
			PFD_DRAW_TO_WINDOW |            // support window
			PFD_SUPPORT_OPENGL |            // support OpenGL
			PFD_DOUBLEBUFFER |              // double buffered
			PFD_STEREO_DONTCARE, 
			PFD_TYPE_RGBA,                  // RGBA type
			32,                             // 32-bit color depth
			8, 16, 8, 8, 8, 0,               // color bits ignored
			0,                              // no alpha buffer
			0,                              // shift bit ignored
			64,                              // accumulation buffer
			16, 16, 16, 0,                     // accum bits ignored
			32,                             // 32-bit z-buffer
			8,                              // no stencil buffer
			0,                              // no auxiliary buffer
			PFD_MAIN_PLANE,                 // main layer
			0,                              // reserved
			0, 0, 0                         // layer masks ignored
    };

	if(pfd.dwFlags & PFD_NEED_PALETTE)
		AfxMessageBox("Colors will not display properly,\nOnly 256 colors available\nNo palette handling included");

	int nPixelFormat = ChoosePixelFormat(hDC, &pfd);
	if (nPixelFormat == 0)  // choose default
	{
		nPixelFormat = 1;
		if (DescribePixelFormat(hDC, nPixelFormat, sizeof(PIXELFORMATDESCRIPTOR), &pfd) == 0)
			return FALSE;
	}

	if (!SetPixelFormat(hDC, nPixelFormat, &pfd))
		return FALSE;

	return TRUE;
}


//********************************************
// CreateViewGLContext
// Create an OpenGL rendering context
//********************************************
BOOL COpenGLView::CreateViewGLContext(HDC hDC)
{
	// create rendering context associated with windows dc
	m_hRC = wglCreateContext(hDC);

	if (m_hRC == NULL)
		return FALSE;	
	
	// keep it current in the windows lifetime
	// if you do not change it in subclass
	if (wglMakeCurrent(hDC, m_hRC) == FALSE)
		return FALSE;

	return TRUE;
}


void COpenGLView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_ptLeftPrevDownPos = point;
	m_bLeftButtonDown = TRUE;
	
	SetCapture();	
	
	CView::OnLButtonDown(nFlags, point);
}


void COpenGLView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_bLeftButtonDown = FALSE;
	m_bRightButtonDown = FALSE;
	
	ReleaseCapture();
	
	CView::OnLButtonUp(nFlags, point);
}


void COpenGLView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_ptRightPrevDownPos = point;
	m_bRightButtonDown = TRUE;

	SetCapture();
	
	CView::OnRButtonDown(nFlags, point);
}


void COpenGLView::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_bLeftButtonDown = FALSE;
	m_bRightButtonDown = FALSE;
	
	ReleaseCapture();
	
	CView::OnRButtonUp(nFlags, point);
}


void COpenGLView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Both : x / y translation
	if(m_bLeftButtonDown && m_bRightButtonDown && (!m_bLockScaleAndTrans))
	{
		m_xTranslation -= (float)(m_ptLeftPrevDownPos.x - point.x) * m_SpeedTranslation;
		m_yTranslation += (float)(m_ptLeftPrevDownPos.y - point.y) * m_SpeedTranslation;
		
		m_ptLeftPrevDownPos = point;		
		InvalidateRect(NULL);
	}
	
	else if(m_bLeftButtonDown)// Left : rotation
	{
		if(m_bXZRotation)
		{
			m_zRotation -= (float)(m_ptLeftPrevDownPos.x - point.x) * m_SpeedRotation;
			m_xRotation -= (float)(m_ptLeftPrevDownPos.y - point.y) * m_SpeedRotation;
		}
		else
		{
			m_yRotation -= (float)(m_ptLeftPrevDownPos.x - point.x) * m_SpeedRotation;
			m_xRotation -= (float)(m_ptLeftPrevDownPos.y - point.y) * m_SpeedRotation;
		}
		
		m_ptLeftPrevDownPos = point;		
		InvalidateRect(NULL);
	}
	
	else if(m_bRightButtonDown && (!m_bLockScaleAndTrans))// Right : z translation
	{
//		//Note: gluPerspectiveʱ
//		m_zTranslation += (float)(m_ptRightPrevDownPos.y - point.y) * m_SpeedTranslation;

		// glOrtho
		if (abs(m_ptRightPrevDownPos.y - point.y) > 2)
		{
			if (m_ptRightPrevDownPos.y - point.y < 0) 
				m_Scaling /= m_SpeedScaling;
			else
				m_Scaling *= m_SpeedScaling;
		}

		m_ptRightPrevDownPos = point;		
		InvalidateRect(NULL);
	}
	
	CView::OnMouseMove(nFlags, point);
}


void COpenGLView::ViewPosTop() 
{
	m_xRotation = 0.0;
	m_yRotation = 0.0;
	m_zRotation = 0.0;

	InvalidateRect(NULL);
}


void COpenGLView::ViewPosBottom() 
{
	m_xRotation = -180.0;
	m_yRotation = 0.0;
	m_zRotation = 0.0;

	InvalidateRect(NULL);
}


void COpenGLView::ViewPosFront() 
{
	m_xRotation = -90.0;
	m_yRotation = 0.0;
	m_zRotation = 0.0;

	InvalidateRect(NULL);
}

void COpenGLView::ViewPosBack() 
{
	m_xRotation = -90.0;
	m_yRotation = 0.0;
	m_zRotation = -180.0;

	InvalidateRect(NULL);
}

void COpenGLView::ViewPosLeft() 
{
	m_xRotation = -90.0;
	m_yRotation = 0.0;
	m_zRotation = 90.0;

	InvalidateRect(NULL);
}

void COpenGLView::ViewPosRight() 
{
	m_xRotation = -90.0;
	m_yRotation = 0.0;
	m_zRotation = -90.0;

	InvalidateRect(NULL);
}


void COpenGLView::ViewPosTrimetric()
{
	m_xRotation = -45.0;
	m_yRotation = 0.0;
	m_zRotation = -45.0;

	InvalidateRect(NULL);
}


void COpenGLView::ViewFitWindow() 
{
	// 伴ʵ
	//m_Scaling = 1.0f;
	//m_xTranslation = 0.0f;
	//m_yTranslation = 0.0f;
	//m_zTranslation = 0.0f;

	// øù񶯻һɣʱ300룬15 ֡ҡÿ֡ʱ20
	m_stepScaling = (1.0 - m_Scaling) / 15.0;
	m_stepTransX = (0.0 - m_xTranslation) / 15.0;
	m_stepTransY = (0.0 - m_yTranslation) / 15.0;
	m_stepTransZ = (0.0 - m_zTranslation) / 15.0;

	SetTimer(1, 2, NULL); // 20 = 300 / 15;
	m_bLockScaleAndTrans = true;

	InvalidateRect(NULL);
}


void COpenGLView::ViewLight()
{
	m_bEnableLighting = !m_bEnableLighting;
	if (m_bEnableLighting)
		glEnable(GL_LIGHTING);
	else
		glDisable(GL_LIGHTING);

	InvalidateRect(NULL);
}


void COpenGLView::ViewLightBothSides()
{
	m_bEnableBothSidesLights = !m_bEnableBothSidesLights;
	if (m_bEnableBothSidesLights)
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE); 
	else
		glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_FALSE);

	InvalidateRect(NULL);
}


void COpenGLView::ViewCoordinate()
{
	m_bShowCoordinate = !m_bShowCoordinate;
	InvalidateRect(NULL);
}


void COpenGLView::PrepareAxisLabel()
{
	GLubyte m_RasterFont[][13] = 
	{
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18}, 
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x36, 0x36, 0x36}, 
		{0x00, 0x00, 0x00, 0x66, 0x66, 0xff, 0x66, 0x66, 0xff, 0x66, 0x66, 0x00, 0x00}, 
		{0x00, 0x00, 0x18, 0x7e, 0xff, 0x1b, 0x1f, 0x7e, 0xf8, 0xd8, 0xff, 0x7e, 0x18}, 
		{0x00, 0x00, 0x0e, 0x1b, 0xdb, 0x6e, 0x30, 0x18, 0x0c, 0x76, 0xdb, 0xd8, 0x70}, 
		{0x00, 0x00, 0x7f, 0xc6, 0xcf, 0xd8, 0x70, 0x70, 0xd8, 0xcc, 0xcc, 0x6c, 0x38}, 
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x1c, 0x0c, 0x0e}, 
		{0x00, 0x00, 0x0c, 0x18, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x18, 0x0c}, 
		{0x00, 0x00, 0x30, 0x18, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x18, 0x30}, 
		{0x00, 0x00, 0x00, 0x00, 0x99, 0x5a, 0x3c, 0xff, 0x3c, 0x5a, 0x99, 0x00, 0x00}, 
		{0x00, 0x00, 0x00, 0x18, 0x18, 0x18, 0xff, 0xff, 0x18, 0x18, 0x18, 0x00, 0x00}, 
		{0x00, 0x00, 0x30, 0x18, 0x1c, 0x1c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x00, 0x38, 0x38, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x60, 0x60, 0x30, 0x30, 0x18, 0x18, 0x0c, 0x0c, 0x06, 0x06, 0x03, 0x03}, 
		{0x00, 0x00, 0x3c, 0x66, 0xc3, 0xe3, 0xf3, 0xdb, 0xcf, 0xc7, 0xc3, 0x66, 0x3c}, 
		{0x00, 0x00, 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x78, 0x38, 0x18}, 
		{0x00, 0x00, 0xff, 0xc0, 0xc0, 0x60, 0x30, 0x18, 0x0c, 0x06, 0x03, 0xe7, 0x7e}, 
		{0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x07, 0x7e, 0x07, 0x03, 0x03, 0xe7, 0x7e}, 
		{0x00, 0x00, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0xff, 0xcc, 0x6c, 0x3c, 0x1c, 0x0c}, 
		{0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x07, 0xfe, 0xc0, 0xc0, 0xc0, 0xc0, 0xff}, 
		{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc7, 0xfe, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e}, 
		{0x00, 0x00, 0x30, 0x30, 0x30, 0x30, 0x18, 0x0c, 0x06, 0x03, 0x03, 0x03, 0xff}, 
		{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xe7, 0x7e, 0xe7, 0xc3, 0xc3, 0xe7, 0x7e}, 
		{0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x03, 0x7f, 0xe7, 0xc3, 0xc3, 0xe7, 0x7e}, 
		{0x00, 0x00, 0x00, 0x38, 0x38, 0x00, 0x00, 0x38, 0x38, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x30, 0x18, 0x1c, 0x1c, 0x00, 0x00, 0x1c, 0x1c, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x06, 0x0c, 0x18, 0x30, 0x60, 0xc0, 0x60, 0x30, 0x18, 0x0c, 0x06}, 
		{0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x60, 0x30, 0x18, 0x0c, 0x06, 0x03, 0x06, 0x0c, 0x18, 0x30, 0x60}, 
		{0x00, 0x00, 0x18, 0x00, 0x00, 0x18, 0x18, 0x0c, 0x06, 0x03, 0xc3, 0xc3, 0x7e}, 
		{0x00, 0x00, 0x3f, 0x60, 0xcf, 0xdb, 0xd3, 0xdd, 0xc3, 0x7e, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0x66, 0x3c, 0x18}, 
		{0x00, 0x00, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe}, 
		{0x00, 0x00, 0x7e, 0xe7, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e}, 
		{0x00, 0x00, 0xfc, 0xce, 0xc7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc7, 0xce, 0xfc}, 
		{0x00, 0x00, 0xff, 0xc0, 0xc0, 0xc0, 0xc0, 0xfc, 0xc0, 0xc0, 0xc0, 0xc0, 0xff}, 
		{0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfc, 0xc0, 0xc0, 0xc0, 0xff}, 
		{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xcf, 0xc0, 0xc0, 0xc0, 0xc0, 0xe7, 0x7e}, 
		{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xff, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3}, 
		{0x00, 0x00, 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x7e}, 
		{0x00, 0x00, 0x7c, 0xee, 0xc6, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0x06}, 
		{0x00, 0x00, 0xc3, 0xc6, 0xcc, 0xd8, 0xf0, 0xe0, 0xf0, 0xd8, 0xcc, 0xc6, 0xc3}, 
		{0x00, 0x00, 0xff, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0}, 
		{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xdb, 0xff, 0xff, 0xe7, 0xc3}, 
		{0x00, 0x00, 0xc7, 0xc7, 0xcf, 0xcf, 0xdf, 0xdb, 0xfb, 0xf3, 0xf3, 0xe3, 0xe3}, 
		{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xe7, 0x7e}, 
		{0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe}, 
		{0x00, 0x00, 0x3f, 0x6e, 0xdf, 0xdb, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0x66, 0x3c}, 
		{0x00, 0x00, 0xc3, 0xc6, 0xcc, 0xd8, 0xf0, 0xfe, 0xc7, 0xc3, 0xc3, 0xc7, 0xfe}, 
		{0x00, 0x00, 0x7e, 0xe7, 0x03, 0x03, 0x07, 0x7e, 0xe0, 0xc0, 0xc0, 0xe7, 0x7e}, 
		{0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0xff}, 
		{0x00, 0x00, 0x7e, 0xe7, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3}, 
		{0x00, 0x00, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3}, 
		{0x00, 0x00, 0xc3, 0xe7, 0xff, 0xff, 0xdb, 0xdb, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3}, 
		{0x00, 0x00, 0xc3, 0x66, 0x66, 0x3c, 0x3c, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3}, 
		{0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3}, 
		{0x00, 0x00, 0xff, 0xc0, 0xc0, 0x60, 0x30, 0x7e, 0x0c, 0x06, 0x03, 0x03, 0xff}, 
		{0x00, 0x00, 0x3c, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x3c}, 
		{0x00, 0x03, 0x03, 0x06, 0x06, 0x0c, 0x0c, 0x18, 0x18, 0x30, 0x30, 0x60, 0x60}, 
		{0x00, 0x00, 0x3c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x3c}, 
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xc3, 0x66, 0x3c, 0x18}, 
		{0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x38, 0x30, 0x70}, 
		{0x00, 0x00, 0x7f, 0xc3, 0xc3, 0x7f, 0x03, 0xc3, 0x7e, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xfe, 0xc3, 0xc3, 0xc3, 0xc3, 0xfe, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0}, 
		{0x00, 0x00, 0x7e, 0xc3, 0xc0, 0xc0, 0xc0, 0xc3, 0x7e, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x7f, 0xc3, 0xc3, 0xc3, 0xc3, 0x7f, 0x03, 0x03, 0x03, 0x03, 0x03}, 
		{0x00, 0x00, 0x7f, 0xc0, 0xc0, 0xfe, 0xc3, 0xc3, 0x7e, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x30, 0x30, 0x30, 0x30, 0x30, 0xfc, 0x30, 0x30, 0x30, 0x33, 0x1e}, 
		{0x7e, 0xc3, 0x03, 0x03, 0x7f, 0xc3, 0xc3, 0xc3, 0x7e, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xfe, 0xc0, 0xc0, 0xc0, 0xc0}, 
		{0x00, 0x00, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00, 0x18, 0x00}, 
		{0x38, 0x6c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x0c, 0x00, 0x00, 0x0c, 0x00}, 
		{0x00, 0x00, 0xc6, 0xcc, 0xf8, 0xf0, 0xd8, 0xcc, 0xc6, 0xc0, 0xc0, 0xc0, 0xc0}, 
		{0x00, 0x00, 0x7e, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x78}, 
		{0x00, 0x00, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xdb, 0xfe, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0xfc, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x7c, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0x7c, 0x00, 0x00, 0x00, 0x00}, 
		{0xc0, 0xc0, 0xc0, 0xfe, 0xc3, 0xc3, 0xc3, 0xc3, 0xfe, 0x00, 0x00, 0x00, 0x00}, 
		{0x03, 0x03, 0x03, 0x7f, 0xc3, 0xc3, 0xc3, 0xc3, 0x7f, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xc0, 0xc0, 0xc0, 0xc0, 0xc0, 0xe0, 0xfe, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xfe, 0x03, 0x03, 0x7e, 0xc0, 0xc0, 0x7f, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x1c, 0x36, 0x30, 0x30, 0x30, 0x30, 0xfc, 0x30, 0x30, 0x30, 0x00}, 
		{0x00, 0x00, 0x7e, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0xc6, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x18, 0x3c, 0x3c, 0x66, 0x66, 0xc3, 0xc3, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xc3, 0xe7, 0xff, 0xdb, 0xc3, 0xc3, 0xc3, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xc3, 0x66, 0x3c, 0x18, 0x3c, 0x66, 0xc3, 0x00, 0x00, 0x00, 0x00}, 
		{0xc0, 0x60, 0x60, 0x30, 0x18, 0x3c, 0x66, 0x66, 0xc3, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0xff, 0x60, 0x30, 0x18, 0x0c, 0x06, 0xff, 0x00, 0x00, 0x00, 0x00}, 
		{0x00, 0x00, 0x0f, 0x18, 0x18, 0x18, 0x38, 0xf0, 0x38, 0x18, 0x18, 0x18, 0x0f}, 
		{0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18}, 
		{0x00, 0x00, 0xf0, 0x18, 0x18, 0x18, 0x1c, 0x0f, 0x1c, 0x18, 0x18, 0x18, 0xf0}, 
		{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x8f, 0xf1, 0x60, 0x00, 0x00, 0x00} 
	};
	
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    m_nFontOffset = glGenLists(128);
    for (GLuint i = 32; i < 127; i++)
	{
		glNewList(i + m_nFontOffset, GL_COMPILE);
			glBitmap(8, 13, 0.0f, 0.0f, 0.0f, 0.0f, m_RasterFont[i-32]);
		glEndList();
    }
}


void COpenGLView::PrintAxisLabel(const char* str)
{
    glPushAttrib(GL_LIST_BIT);
    glListBase(m_nFontOffset);
	glCallLists(static_cast<GLsizei>(strlen(str)), GL_UNSIGNED_BYTE, (GLubyte*)str);
    glPopAttrib();
}


void COpenGLView::BuildAxisesList()
{
	m_nAxisesList = glGenLists(1);
	glNewList(m_nAxisesList, GL_COMPILE);
		
		glLineWidth(2.0f);
		glBegin(GL_LINES);
			glColor3ub(255, 0, 0); 
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.3, 0.0, 0.0);

			glColor3ub(0, 255, 0);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, 0.3, 0.0);
			
			glColor3ub(0, 0, 255);   
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, 0.0, 0.3);
		glEnd();
	
		//ϵļͷע"X,Y,Z"
		glColor3ub(255, 255, 255);	
		glRasterPos3f(0.4, 0.0, 0.0);	PrintAxisLabel("X");
		glRasterPos3f(0.0, 0.4, 0.0);	PrintAxisLabel("Y");	
		glRasterPos3f(0.0, 0.0, 0.4);	PrintAxisLabel("Z");
		//x
		glPushMatrix();
			glColor3ub(255, 0, 0);
			glTranslatef(0.3, 0.0, 0.0);
			glRotatef(90.0, 0.0, 1.0, 0.0);
			glutSolidCone(0.02, 0.07, 10, 10);
		glPopMatrix();
		//y
		glPushMatrix();
			glColor3ub(0, 255, 0);
			glTranslatef(0.0, 0.3, 0.0);
			glRotatef(-90.0, 1.0, 0.0, 0.0);
			glutSolidCone(0.02, 0.07, 10, 10);
		glPopMatrix();
		//z
		glPushMatrix();
			glColor3ub(0, 0, 255); //ûйʱģɫΪɫܸıɫ
			glTranslatef(0.0, 0.0, 0.3);
			glutSolidCone(0.02, 0.07, 10, 10);	
		glPopMatrix();
	glEndList();
}


void COpenGLView::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: Add your message handler code here and/or call default
	m_Scaling += m_stepScaling;
	m_xTranslation += m_stepTransX;
	m_yTranslation += m_stepTransY;
	m_zTranslation += m_stepTransZ;

	if (fabs(m_Scaling - 1.0f) + fabs(m_xTranslation) + fabs(m_yTranslation) + fabs(m_zTranslation) < 0.001)
	{
		KillTimer(1);
		m_bLockScaleAndTrans = false;
	}

	InvalidateRect(NULL);

	CView::OnTimer(nIDEvent);
}