// NCSimuView.cpp : implementation of the CNCSimuView class
//

#include "stdafx.h"
#include "NCSimu.h"

#include "NCSimuDoc.h"
#include "NCSimuView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNCSimuView

IMPLEMENT_DYNCREATE(CNCSimuView, COpenGLView)

BEGIN_MESSAGE_MAP(CNCSimuView, COpenGLView)
	//{{AFX_MSG_MAP(CNCSimuView)
	ON_COMMAND(ID_MOTION_STOP_ALL, OnMotionStopAll)
	ON_COMMAND(ID_MOTION_NEGATIVE_X, OnMotionNegativeX)
	ON_COMMAND(ID_MOTION_POSITIVE_X, OnMotionPositiveX)
	ON_COMMAND(ID_MOTION_NEGATIVE_Y, OnMotionNegativeY)
	ON_COMMAND(ID_MOTION_POSITIVE_Y, OnMotionPositiveY)
	ON_COMMAND(ID_MOTION_NEGATIVE_Z, OnMotionNegativeZ)
	ON_COMMAND(ID_MOTION_POSITIVE_Z, OnMotionPositiveZ)
	ON_WM_TIMER()
	ON_COMMAND(ID_MOTION_POSITIVE_A, OnMotionPositiveA)
	ON_COMMAND(ID_MOTION_POSITIVE_C, OnMotionPositiveC)
	ON_COMMAND(ID_MOTION_NEGATIVE_A, OnMotionNegativeA)
	ON_COMMAND(ID_MOTION_NEGATIVE_C, OnMotionNegativeC)
	ON_COMMAND(ID_MOTION_RESET, OnMotionReset)
	ON_COMMAND(ID_MACHINING_PAUSE, OnMachiningPause)
	ON_COMMAND(ID_MACHINING_START, OnMachiningStart)
	ON_COMMAND(ID_MACHINING_STOP, OnMachiningStop)
	ON_UPDATE_COMMAND_UI(ID_MACHINING_START, OnUpdateMachiningStart)
	ON_UPDATE_COMMAND_UI(ID_MACHINING_PAUSE, OnUpdateMachiningPause)
	ON_UPDATE_COMMAND_UI(ID_MACHINING_STOP, OnUpdateMachiningStop)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, COpenGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, COpenGLView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, COpenGLView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNCSimuView construction/destruction

CNCSimuView::CNCSimuView()
{
	// TODO: add construction code here

	count = 0;

	m_nIDEventMachine = 2;

	m_nMachineStatus = STOP;

	m_nListTool = 0;
	m_nListToolBase = 0;
	m_dMachineX = 0;
	m_dMachineY = 0;
	m_dMachineZ = 0;
	m_dMachineA = 0;
	m_dMachineC = 0;

	m_bInMotionPositiveX = false;
	m_bInMotionPositiveY = false;
	m_bInMotionPositiveZ = false;
	m_bInMotionPositiveA = false;
	m_bInMotionPositiveC = false;

	m_bInMotionNegativeX = false;
	m_bInMotionNegativeY = false;
	m_bInMotionNegativeZ = false;
	m_bInMotionNegativeA = false;
	m_bInMotionNegativeC = false;
}

CNCSimuView::~CNCSimuView()
{
}

BOOL CNCSimuView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return COpenGLView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CNCSimuView drawing

void CNCSimuView::OnDraw(CDC* pDC)
{
	CNCSimuDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here

	COpenGLView::OnDraw(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CNCSimuView printing

BOOL CNCSimuView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CNCSimuView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CNCSimuView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CNCSimuView diagnostics

#ifdef _DEBUG
void CNCSimuView::AssertValid() const
{
	COpenGLView::AssertValid();
}

void CNCSimuView::Dump(CDumpContext& dc) const
{
	COpenGLView::Dump(dc);
}

CNCSimuDoc* CNCSimuView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CNCSimuDoc)));
	return (CNCSimuDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNCSimuView message handlers

void CNCSimuView::RenderSceneScalable()
{	
	CNCSimuDoc *pDoc = GetDocument();
	//////////////////////////////////////////////////////////////////////////

	if (pDoc->m_bExistToolPath)
		glScaled(pDoc->m_toolPath.m_dFitWndScale, pDoc->m_toolPath.m_dFitWndScale, pDoc->m_toolPath.m_dFitWndScale); 
	else
		glScalef(0.05, 0.05, 0.05);

	//////////////////////////////////////////////////////////////////////////

	// ʾӹ·
	glDisable(GL_LIGHTING);
	pDoc->m_toolPath.Draw();
	glEnable(GL_LIGHTING);
	

	// ݻ״̬ȷλ
	switch(m_nMachineStatus)
	{
	case STOP:
		glTranslatef(pDoc->m_toolPath.m_dMinX + 3, pDoc->m_toolPath.m_dMinY + 3, pDoc->m_toolPath.m_dMaxZ + 15);
		break;
	case MACHINING:
		break;
	case PAUSE:
	    break;
	case FINISHED:
		glTranslatef(pDoc->m_toolPath.m_dMinX + 3, pDoc->m_toolPath.m_dMinY + 3, pDoc->m_toolPath.m_dMaxZ + 15);
	    break;
	default:
	    break;
	}

	// ƽ˶	
	glTranslatef(m_dMachineX, m_dMachineY, m_dMachineZ);

	// ʱΪ30˴С1/3ڼʱӦȡ10 
	glScalef(1.0/3.0, 1.0/3.0, 1.0/3.0);  
	glRotatef(m_dMachineC, 0.0, 0.0, 1.0);
	
	glCallList(m_nListToolBase);

	glRotatef(m_dMachineA, 1.0, 0.0, 0.0);
	glCallList(m_nListTool);	
}


void CNCSimuView::RenderSceneUnScalable()
{
	//
	glCallList(m_nAxisesList);	
}

// _____________________
// |___________________|
//   | |           | |    toolBase    
//	 | ||---------|| |
//	 | ||         || | 
//	 |_||   cube  ||_|
//	    |_________|
//	      |_____|   tool
//          | |
//	        | | 
//	        | |      
//	        |_|
      

void CNCSimuView::BuildListMachine()
{
	/*ĸ*/
	GLUquadricObj *quadObj;
	
	/*ĸ*/
	quadObj = gluNewQuadric();
	//gluQuadricNormals(quadObj, GL_SMOOTH);

	// tool base
	m_nListToolBase = glGenLists(1);
	glNewList(m_nListToolBase, GL_COMPILE);
	
		SetMaterial(5);			
		glPushMatrix();		
			glTranslatef(0.0, 0.0, 12);
			gluCylinder(quadObj, 15, 15, 5, 50, 1);			
			gluDisk(quadObj, 0.0, 15, 50, 1);
			glTranslatef(0.0, 0.0, 5);
			gluDisk(quadObj, 0.0, 15, 50, 1);			
 		glPopMatrix();

		// Aװ
		SetMaterial(2);
		glPushMatrix();
			glTranslatef(-13, 0.0, 0.0);
			glRotatef(90.0, 0.0, 1.0, 0.0);
			gluCylinder(quadObj, 3, 3, 26, 30, 1);
			gluDisk(quadObj, 0.0, 3, 50, 1);
			glTranslatef(0.0, 0.0, 26);
			gluDisk(quadObj, 0.0, 3, 50, 1);
		glPopMatrix();				
  
		SetMaterial(5);
  		glPushMatrix();
			glBegin(GL_QUADS);					
				glNormal3f(-1.0, 0.0, 0.0);
				glVertex3f(-12, -5,  12);
				glVertex3f(-12,  5,  12);
				glVertex3f(-12,  5, -5);
				glVertex3f(-12, -5, -5);
				
				glNormal3f(-1.0, 0.0, 0.0);
				glVertex3f( 9, -5,  12);
				glVertex3f( 9,  5,  12);
				glVertex3f( 9,  5, -5);
				glVertex3f( 9, -5, -5);

				glNormal3f(1.0, 0.0, 0.0);
				glVertex3f(-9, -5,  12);
				glVertex3f(-9, -5, -5);
				glVertex3f(-9,  5, -5);
				glVertex3f(-9,  5,  12);
				
				glNormal3f(1.0, 0.0, 0.0);
				glVertex3f( 12, -5,  12);
				glVertex3f( 12, -5, -5);
				glVertex3f( 12,  5, -5);	
				glVertex3f( 12,  5,  12);

				glNormal3f(0.0, 0.0, -1.0);
				glVertex3f( 12, -5, -5);
				glVertex3f( 9, -5, -5);
				glVertex3f( 9,  5, -5);
				glVertex3f( 12,  5, -5);
				
				glNormal3f(0.0, 0.0, -1.0);
				glVertex3f(-12, -5, -5);
				glVertex3f(-12,  5, -5);
				glVertex3f(-9,  5, -5);	
				glVertex3f(-9, -5, -5);
				
				glNormal3f(0.0, 1.0, 0.0);
				glVertex3f( 12,  5,  12);
				glVertex3f( 12,  5, -5);
				glVertex3f( 9,  5, -5);	
				glVertex3f( 9,  5,  12);
				
				glNormal3f(0.0, -1.0, 0.0);
				glVertex3f( 12, -5,  12);
				glVertex3f( 9, -5,  12);
				glVertex3f( 9, -5, -5);
				glVertex3f( 12, -5, -5);
				
				glNormal3f(0.0, 1.0, 0.0);
				glVertex3f(-12,  5,  12);
				glVertex3f(-9,  5,  12);
				glVertex3f(-9,  5, -5);
				glVertex3f(-12,  5, -5);				
				
				glNormal3f(0.0, -1.0, 0.0);
				glVertex3f(-12, -5,  12);
				glVertex3f(-12, -5, -5);
				glVertex3f(-9, -5, -5);				
				glVertex3f(-9, -5,  12);
			glEnd();
 		glPopMatrix();
	glEndList();


	// tool list
	m_nListTool = glGenLists(1);
	glNewList(m_nListTool, GL_COMPILE);	
		SetMaterial(11);
		glutSolidCube(16);

		SetMaterial(5);
		glPushMatrix();
			glTranslatef(0.0, 0.0, -10);
			gluDisk(quadObj, 0.0, 7, 50, 1);
			gluCylinder(quadObj, 7, 7, 2, 50, 1);
		glPopMatrix();

		SetMaterial(10);
		glPushMatrix();	
			glTranslatef(0.0, 0.0, -30);	
			gluCylinder(quadObj, 2, 2, 20, 20, 1);
			glutSolidSphere(2, 20, 20);
		glPopMatrix();

	glEndList();

	// ɾ
	gluDeleteQuadric(quadObj);
}


void CNCSimuView::OnMotionStopAll() 
{
	// TODO: Add your command handler code here
	m_bInMotionPositiveX = false;
	m_bInMotionPositiveY = false;
	m_bInMotionPositiveZ = false;
	m_bInMotionPositiveA = false;
	m_bInMotionPositiveC = false;

	m_bInMotionNegativeX = false;
	m_bInMotionNegativeY = false;
	m_bInMotionNegativeZ = false;
	m_bInMotionNegativeA = false;
	m_bInMotionNegativeC = false;
	
	InvalidateRect(NULL);
}



void CNCSimuView::OnMotionPositiveA() 
{
	// TODO: Add your command handler code here
	m_bInMotionPositiveA = true;
	m_bInMotionNegativeA = false;
}

void CNCSimuView::OnMotionPositiveC() 
{
	// TODO: Add your command handler code here
	m_bInMotionPositiveC = true;
	m_bInMotionNegativeC = false;
}

void CNCSimuView::OnMotionNegativeA() 
{
	// TODO: Add your command handler code here
	m_bInMotionNegativeA = true;
	m_bInMotionPositiveA = false;
}

void CNCSimuView::OnMotionNegativeC() 
{
	// TODO: Add your command handler code here
	m_bInMotionNegativeC = true;
	m_bInMotionPositiveC = false;
}


void CNCSimuView::OnMotionNegativeX() 
{
	// TODO: Add your command handler code here
	m_bInMotionNegativeX = true;
	m_bInMotionPositiveX = false;
}

void CNCSimuView::OnMotionPositiveX() 
{
	// TODO: Add your command handler code here
	m_bInMotionPositiveX = true;
	m_bInMotionNegativeX = false;
}

void CNCSimuView::OnMotionNegativeY() 
{
	// TODO: Add your command handler code here
	m_bInMotionNegativeY = true;
	m_bInMotionPositiveY = false;
}

void CNCSimuView::OnMotionPositiveY() 
{
	// TODO: Add your command handler code here
	m_bInMotionPositiveY = true;
	m_bInMotionNegativeY = false;
}

void CNCSimuView::OnMotionNegativeZ() 
{
	// TODO: Add your command handler code here
	m_bInMotionNegativeZ = true;
	m_bInMotionPositiveZ = false;
}

void CNCSimuView::OnMotionPositiveZ() 
{
	// TODO: Add your command handler code here
	m_bInMotionPositiveZ = true;
	m_bInMotionNegativeZ = false;
}

void CNCSimuView::MachineMoveTo(CMachineCoordinate &mc)
{
	m_dMachineX = mc.x;
	m_dMachineY = mc.y;
	m_dMachineZ = mc.z;
	m_dMachineA = mc.A;
	m_dMachineC = mc.C;
}

void CNCSimuView::MachineMoveTo(double x, double y, double z, double angleA, double angleC)
{
	m_dMachineX = x;
	m_dMachineY = y;
	m_dMachineZ = z;
	m_dMachineA = angleA;
	m_dMachineC = angleC;
}

void CNCSimuView::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if (m_bInMotionPositiveA)
	{
		if ( (m_dMachineA + 1.0) > -115.0 && (m_dMachineA + 1.0) < 115.0)
			m_dMachineA += 1.0;	
	}

	if (m_bInMotionNegativeA)
	{
		if ((m_dMachineA - 1.0) > -115.0 && (m_dMachineA - 1.0) < 115.0)
			m_dMachineA -= 1.0;
	}
	
	if (m_bInMotionPositiveC)
	{
		if ( (m_dMachineC + 1.0) > -200.0 && (m_dMachineC + 1.0) < 200.0)
			m_dMachineC += 1.0;	
	}

	if (m_bInMotionNegativeC)
	{
		if ( (m_dMachineC - 1.0) > -200.0 && (m_dMachineC - 1.0) < 200.0)
			m_dMachineC -= 1.0;	
	}

	if (m_bInMotionPositiveX)
	{
		m_dMachineX += 0.5;
	}

	if (m_bInMotionNegativeX)
	{
		m_dMachineX -= 0.5;
	}

	if (m_bInMotionPositiveY)
	{
		m_dMachineY += 0.5;
	}

	if (m_bInMotionNegativeY)
	{
		m_dMachineY -= 0.5;
	}

	if (m_bInMotionPositiveZ)
	{
		m_dMachineZ += 0.5;
	}

	if (m_bInMotionNegativeZ)
	{
		m_dMachineZ -= 0.5;
	}
	
	// ӹ
	if (m_nMachineStatus == MACHINING)
	{
		if (count < GetDocument()->m_machineCoordinates.size())
			MachineMoveTo(GetDocument()->m_machineCoordinates[count++]);
		else  // ӹϣλ
		{
			count = 0;	
			m_nMachineStatus = FINISHED;
			ResetMachinePositon();
			AfxMessageBox("ӹϣ");
		}
	}

	InvalidateRect(NULL);
	COpenGLView::OnTimer(nIDEvent);
}


void CNCSimuView::OnInitialUpdate() 
{
	COpenGLView::OnInitialUpdate();
	
	// TODO: Add your specialized code here and/or call the base class
	BuildListMachine();

	SetTimer(m_nIDEventMachine, 10, NULL);	
}

void CNCSimuView::OnMotionReset() 
{
	// TODO: Add your command handler code here
	ResetMachinePositon();	
}

void CNCSimuView::ResetMachinePositon()
{
	m_dMachineX = 0;
	m_dMachineY = 0;
	m_dMachineZ = 0;
	m_dMachineA = 0;
	m_dMachineC = 0;
}


void CNCSimuView::OnMachiningPause() 
{
	// TODO: Add your command handler code here
	if (m_nMachineStatus == MACHINING)
		m_nMachineStatus = PAUSE;	
}

void CNCSimuView::OnMachiningStart() 
{
	// TODO: Add your command handler code here
	CNCSimuDoc *pDoc = GetDocument();
	if (!pDoc->m_bExistToolPath)
	{
		AfxMessageBox("·ڣ");
		return;
	}

	if (!GetDocument()->m_toolPath.m_bMachineCoordinatesDone)
	{
		AfxMessageBox("δ");
		return;
	}

	m_nMachineStatus = MACHINING;	
}

void CNCSimuView::OnMachiningStop() 
{
	// TODO: Add your command handler code here
	if (m_nMachineStatus == MACHINING || m_nMachineStatus == PAUSE)
	{
		count = 0;
		ResetMachinePositon();
		m_nMachineStatus = STOP;	
	}
}

void CNCSimuView::OnUpdateMachiningStart(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_nMachineStatus == MACHINING ? true : false);	
}

void CNCSimuView::OnUpdateMachiningPause(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_nMachineStatus == PAUSE ? true : false);	
}

void CNCSimuView::OnUpdateMachiningStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_nMachineStatus == STOP ? true : false);		
}
