// NCSimuView.h : interface of the CNCSimuView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_NCSIMUVIEW_H__A80A3513_D2EE_48EE_95AB_A9F513CFB085__INCLUDED_)
#define AFX_NCSIMUVIEW_H__A80A3513_D2EE_48EE_95AB_A9F513CFB085__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\\OpenGLViewDLL\\OpenGLView.h"


#define MACHINING 0
#define PAUSE     1
#define STOP      2
#define FINISHED  3

class CNCSimuView : public COpenGLView
{
protected: // create from serialization only
	CNCSimuView();
	DECLARE_DYNCREATE(CNCSimuView)

// Attributes
public:
	CNCSimuDoc* GetDocument();

// Operations
public:
	virtual void RenderSceneScalable();
	virtual void RenderSceneUnScalable();
	void BuildListMachine();

	// û
	void MachineMoveTo(double x, double y, double z, double angleA, double angleC);
	void MachineMoveTo(CMachineCoordinate &mc);

	// ûλ
	void ResetMachinePositon();

private:
	GLint m_nListTool;
	GLint m_nListToolBase;

	int m_nIDEventMachine;

	// ״̬
	unsigned int m_nMachineStatus;
	
	// ꣨x,y,zƶ룬A,CתǶ 
	double m_dMachineX;
	double m_dMachineY;
	double m_dMachineZ;
	double m_dMachineA;
	double m_dMachineC;

	// Ƿ˶
	bool m_bInMotionPositiveX;
	bool m_bInMotionPositiveY;
	bool m_bInMotionPositiveZ;
	bool m_bInMotionPositiveA;
	bool m_bInMotionPositiveC;
	bool m_bInMotionNegativeX;
	bool m_bInMotionNegativeY;
	bool m_bInMotionNegativeZ;
	bool m_bInMotionNegativeA;
	bool m_bInMotionNegativeC;

	unsigned long count; 
	
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNCSimuView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CNCSimuView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CNCSimuView)
	afx_msg void OnMotionStopAll();
	afx_msg void OnMotionNegativeX();
	afx_msg void OnMotionPositiveX();
	afx_msg void OnMotionNegativeY();
	afx_msg void OnMotionPositiveY();
	afx_msg void OnMotionNegativeZ();
	afx_msg void OnMotionPositiveZ();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnMotionPositiveA();
	afx_msg void OnMotionPositiveC();
	afx_msg void OnMotionNegativeA();
	afx_msg void OnMotionNegativeC();
	afx_msg void OnMotionReset();
	afx_msg void OnMachiningPause();
	afx_msg void OnMachiningStart();
	afx_msg void OnMachiningStop();
	afx_msg void OnUpdateMachiningStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMachiningPause(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMachiningStop(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in NCSimuView.cpp
inline CNCSimuDoc* CNCSimuView::GetDocument()
   { return (CNCSimuDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NCSIMUVIEW_H__A80A3513_D2EE_48EE_95AB_A9F513CFB085__INCLUDED_)
